Index: cpp/frams/model/similarity/simil_model.cpp
===================================================================
--- cpp/frams/model/similarity/simil_model.cpp	(revision 605)
+++ cpp/frams/model/similarity/simil_model.cpp	(revision 606)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -14,7 +14,7 @@
 #include <frams/vm/classes/genoobj.h>
 #ifdef EMSCRIPTEN
-  #include <cstdlib>
+#include <cstdlib>
 #else
-  #include <stdlib.h>
+#include <stdlib.h>
 #endif
 #include <math.h>
@@ -34,12 +34,12 @@
 
 static ParamEntry MSparam_tab[] = {
-    {"Creature: Similarity", 1, 6, "ModelSimilarity", "Evaluates morphological dissimilarity. More information:\nhttp://www.framsticks.com/node/795\nhttp://www.framsticks.com/node/890", },
-    {"simil_parts", 0, 0, "Weight of parts count", "f 0 100 0", FIELD(m_adFactors[0]), "Differing number of parts is also handled by the 'part degree' similarity component.",},
-    {"simil_partdeg", 0, 0, "Weight of parts' degree", "f 0 100 1", FIELD(m_adFactors[1]), "",},
-    {"simil_neuro", 0, 0, "Weight of neurons count", "f 0 100 0.1", FIELD(m_adFactors[2]), "",},
-    {"simil_partgeom", 0, 0, "Weight of parts' geometric distances", "f 0 100 0", FIELD(m_adFactors[3]), "",},
-	{"simil_fixedZaxis", 0, 0, "Fix 'z' (vertical) axis?", "d 0 1 0", FIELD(fixedZaxis), "", },
-	{"evaluateDistance", 0, PARAM_DONTSAVE | PARAM_USERHIDDEN, "evaluate model dissimilarity", "p f(oGeno,oGeno)", PROCEDURE(p_evaldistance), "Calculates dissimilarity between two models created from Geno objects.", },
-    {0,},
+		{ "Creature: Similarity", 1, 6, "ModelSimilarity", "Evaluates morphological dissimilarity. More information:\nhttp://www.framsticks.com/node/795\nhttp://www.framsticks.com/node/890", },
+		{ "simil_parts", 0, 0, "Weight of parts count", "f 0 100 0", FIELD(m_adFactors[0]), "Differing number of parts is also handled by the 'part degree' similarity component.", },
+		{ "simil_partdeg", 0, 0, "Weight of parts' degree", "f 0 100 1", FIELD(m_adFactors[1]), "", },
+		{ "simil_neuro", 0, 0, "Weight of neurons count", "f 0 100 0.1", FIELD(m_adFactors[2]), "", },
+		{ "simil_partgeom", 0, 0, "Weight of parts' geometric distances", "f 0 100 0", FIELD(m_adFactors[3]), "", },
+		{ "simil_fixedZaxis", 0, 0, "Fix 'z' (vertical) axis?", "d 0 1 0", FIELD(fixedZaxis), "", },
+		{ "evaluateDistance", 0, PARAM_DONTSAVE | PARAM_USERHIDDEN, "evaluate model dissimilarity", "p f(oGeno,oGeno)", PROCEDURE(p_evaldistance), "Calculates dissimilarity between two models created from Geno objects.", },
+		{ 0, },
 };
 
@@ -54,147 +54,147 @@
 ModelSimil::ModelSimil() : localpar(MSparam_tab, this), m_iDV(0), m_iDD(0), m_iDN(0), m_dDG(0.0)
 {
-    localpar.setDefault();
-
-    m_Gen[0] = NULL;
-    m_Gen[1] = NULL;
-    m_Mod[0] = NULL;
-    m_Mod[1] = NULL;
-    m_aDegrees[0] = NULL;
-    m_aDegrees[1] = NULL;
-    m_aPositions[0] = NULL;
-    m_aPositions[1] = NULL;
-    m_fuzzyNeighb[0] = NULL;
-    m_fuzzyNeighb[1] = NULL;
-    m_Neighbours[0] = NULL;
-    m_Neighbours[1] = NULL;
-    m_pMatching = NULL;
-
-    //Determines whether "fuzzy vertex degree" should be used.
-    //Currently "fuzzy vertex degree" is inactive.
-    isFuzzy = 0;
-    fuzzyDepth = 10;
+	localpar.setDefault();
+
+	m_Gen[0] = NULL;
+	m_Gen[1] = NULL;
+	m_Mod[0] = NULL;
+	m_Mod[1] = NULL;
+	m_aDegrees[0] = NULL;
+	m_aDegrees[1] = NULL;
+	m_aPositions[0] = NULL;
+	m_aPositions[1] = NULL;
+	m_fuzzyNeighb[0] = NULL;
+	m_fuzzyNeighb[1] = NULL;
+	m_Neighbours[0] = NULL;
+	m_Neighbours[1] = NULL;
+	m_pMatching = NULL;
+
+	//Determines whether "fuzzy vertex degree" should be used.
+	//Currently "fuzzy vertex degree" is inactive.
+	isFuzzy = 0;
+	fuzzyDepth = 10;
 }
 
 /**	Evaluates distance between two given genotypes. The distance depends strongly
-    on weights set.
-        @param G0 Pointer to the first of compared genotypes
-        @param G1 Pointer to the second of compared genotypes.
-        @return Distance between two genotypes.
-    @sa m_adFactors, matching_method
- */
+	on weights set.
+	@param G0 Pointer to the first of compared genotypes
+	@param G1 Pointer to the second of compared genotypes.
+	@return Distance between two genotypes.
+	@sa m_adFactors, matching_method
+	*/
 double ModelSimil::EvaluateDistance(const Geno *G0, const Geno *G1)
 {
-    double dResult = 0;
-
-    m_Gen[0] = G0;
-    m_Gen[1] = G1;
-
-    // check whether pointers are not NULL
-    if (m_Gen[0] == NULL || m_Gen[1] == NULL)
-    {
-        DB(printf("ModelSimil::EvaluateDistance - invalid genotypes pointers\n");)
-        return 0.0;
-    }
-    // create models of objects to compare
-    m_Mod[0] = new Model(*(m_Gen[0]));
-    m_Mod[1] = new Model(*(m_Gen[1]));
-
-    // validate models
-    if (m_Mod[0] == NULL || m_Mod[1] == NULL || !(m_Mod[0]->isValid()) || !(m_Mod[1]->isValid()))
-    {
-        DB(printf("ModelSimil::EvaluateDistance - invalid models pointers\n");)
-        return 0.0;
-    }
-
-    // difference in the number of vertices (Parts) - positive
-    // find object that has less parts (m_iSmaller)
-    m_iDV = (m_Mod[0]->getPartCount() - m_Mod[1]->getPartCount());
-    if (m_iDV > 0)
-        m_iSmaller = 1;
-    else
-    {
-        m_iSmaller = 0;
-        m_iDV = -m_iDV;
-    }
-
-    // check if index of the smaller organism is a valid index
-    assert((m_iSmaller == 0) || (m_iSmaller == 1));
-    // validate difference in the parts number
-    assert(m_iDV >= 0);
-
-    // create Parts matching object
-    m_pMatching = new SimilMatching(m_Mod[ 0 ]->getPartCount(), m_Mod[ 1 ]->getPartCount());
-    // validate matching object
-    assert(m_pMatching != NULL);
-    assert(m_pMatching->IsEmpty() == true);
-
-
-    // assign matching function
-    int (ModelSimil::* pfMatchingFunction) () = NULL;
-
-    pfMatchingFunction = &ModelSimil::MatchPartsGeometry;
-
-    // match Parts (vertices of creatures)
-    if ((this->*pfMatchingFunction)() == 0)
-    {
-        DB(printf("ModelSimil::EvaluateDistance - MatchParts() error\n");)
-        return 0.0;
-    }
-
-    // after matching function call we must have full matching
-    assert(m_pMatching->IsFull() == true);
-   
-    DB(SaveIntermediateFiles();) 
-           
-    // count differences in matched parts
-    if (CountPartsDistance() == 0)
-    {
-        DB(printf("ModelSimil::EvaluateDistance - CountPartDistance() error\n");)
-        return 0.0;
-    }
-
-    // delete degree arrays created in CreatePartInfoTables 
-    SAFEDELETEARRAY(m_aDegrees[0]);
-    SAFEDELETEARRAY(m_aDegrees[1]);
-
-    // and position arrays
-    SAFEDELETEARRAY(m_aPositions[0]);
-    SAFEDELETEARRAY(m_aPositions[1]);
-
-    // in fuzzy mode delete arrays of neighbourhood and fuzzy neighbourhood
-    if (isFuzzy)
-    {
-        for (int i = 0; i != 2; ++i)
-        {
-            for (int j = 0; j != m_Mod[i]->getPartCount(); ++j)
-            {
-                delete[] m_Neighbours[i][j];
-                delete[] m_fuzzyNeighb[i][j];
-            }
-            delete[] m_Neighbours[i];
-            delete[] m_fuzzyNeighb[i];
-        }
-
-    }
-    
-    // delete created models
-    SAFEDELETE(m_Mod[0]);
-    SAFEDELETE(m_Mod[1]);
-
-    // delete created matching
-    SAFEDELETE(m_pMatching);
-
-    dResult = m_adFactors[0] * double(m_iDV) +
-            m_adFactors[1] * double(m_iDD) +
-            m_adFactors[2] * double(m_iDN) +
-            m_adFactors[3] * double(m_dDG);
-
-    return dResult;
+	double dResult = 0;
+
+	m_Gen[0] = G0;
+	m_Gen[1] = G1;
+
+	// check whether pointers are not NULL
+	if (m_Gen[0] == NULL || m_Gen[1] == NULL)
+	{
+		DB(printf("ModelSimil::EvaluateDistance - invalid genotypes pointers\n");)
+			return 0.0;
+	}
+	// create models of objects to compare
+	m_Mod[0] = new Model(*(m_Gen[0]));
+	m_Mod[1] = new Model(*(m_Gen[1]));
+
+	// validate models
+	if (m_Mod[0] == NULL || m_Mod[1] == NULL || !(m_Mod[0]->isValid()) || !(m_Mod[1]->isValid()))
+	{
+		DB(printf("ModelSimil::EvaluateDistance - invalid models pointers\n");)
+			return 0.0;
+	}
+
+	// difference in the number of vertices (Parts) - positive
+	// find object that has less parts (m_iSmaller)
+	m_iDV = (m_Mod[0]->getPartCount() - m_Mod[1]->getPartCount());
+	if (m_iDV > 0)
+		m_iSmaller = 1;
+	else
+	{
+		m_iSmaller = 0;
+		m_iDV = -m_iDV;
+	}
+
+	// check if index of the smaller organism is a valid index
+	assert((m_iSmaller == 0) || (m_iSmaller == 1));
+	// validate difference in the parts number
+	assert(m_iDV >= 0);
+
+	// create Parts matching object
+	m_pMatching = new SimilMatching(m_Mod[0]->getPartCount(), m_Mod[1]->getPartCount());
+	// validate matching object
+	assert(m_pMatching != NULL);
+	assert(m_pMatching->IsEmpty() == true);
+
+
+	// assign matching function
+	int (ModelSimil::* pfMatchingFunction) () = NULL;
+
+	pfMatchingFunction = &ModelSimil::MatchPartsGeometry;
+
+	// match Parts (vertices of creatures)
+	if ((this->*pfMatchingFunction)() == 0)
+	{
+		DB(printf("ModelSimil::EvaluateDistance - MatchParts() error\n");)
+			return 0.0;
+	}
+
+	// after matching function call we must have full matching
+	assert(m_pMatching->IsFull() == true);
+
+	DB(SaveIntermediateFiles();)
+
+		// count differences in matched parts
+		if (CountPartsDistance() == 0)
+		{
+		DB(printf("ModelSimil::EvaluateDistance - CountPartDistance() error\n");)
+			return 0.0;
+		}
+
+	// delete degree arrays created in CreatePartInfoTables 
+	SAFEDELETEARRAY(m_aDegrees[0]);
+	SAFEDELETEARRAY(m_aDegrees[1]);
+
+	// and position arrays
+	SAFEDELETEARRAY(m_aPositions[0]);
+	SAFEDELETEARRAY(m_aPositions[1]);
+
+	// in fuzzy mode delete arrays of neighbourhood and fuzzy neighbourhood
+	if (isFuzzy)
+	{
+		for (int i = 0; i != 2; ++i)
+		{
+			for (int j = 0; j != m_Mod[i]->getPartCount(); ++j)
+			{
+				delete[] m_Neighbours[i][j];
+				delete[] m_fuzzyNeighb[i][j];
+			}
+			delete[] m_Neighbours[i];
+			delete[] m_fuzzyNeighb[i];
+		}
+
+	}
+
+	// delete created models
+	SAFEDELETE(m_Mod[0]);
+	SAFEDELETE(m_Mod[1]);
+
+	// delete created matching
+	SAFEDELETE(m_pMatching);
+
+	dResult = m_adFactors[0] * double(m_iDV) +
+		m_adFactors[1] * double(m_iDD) +
+		m_adFactors[2] * double(m_iDN) +
+		m_adFactors[3] * double(m_dDG);
+
+	return dResult;
 }
 
 ModelSimil::~ModelSimil()
 {
-    // matching should have been deleted earlier
-    assert(m_pMatching == NULL);
+	// matching should have been deleted earlier
+	assert(m_pMatching == NULL);
 }
 
@@ -204,220 +204,220 @@
 void ModelSimil::SaveIntermediateFiles()
 {
-    assert(m_pMatching->IsFull() == true);
-    printf("Saving the matching to file 'matching.txt'\n");
-    FILE *pMatchingFile = NULL;
-    // try to open the file
-    pMatchingFile = fopen("matching.txt", "wt");
-    assert(pMatchingFile != NULL);
-
-    int iOrgPart; // original index of a Part
-    int nBigger; // index of the larger organism
-
-    // check which object is bigger
-    if (m_pMatching->GetObjectSize(0) >= m_pMatching->GetObjectSize(1))
-    {
-        nBigger = 0;
-    }
-    else
-    {
-        nBigger = 1;
-    }
-
-    // print first line - original indices of Parts of the bigger organism
-    fprintf(pMatchingFile, "[ ");
-    for (iOrgPart = 0; iOrgPart < m_pMatching->GetObjectSize(nBigger); iOrgPart++)
-    {
-        fprintf(pMatchingFile, "%2i ", iOrgPart);
-    }
-    fprintf(pMatchingFile, "] : ORG[%i]\n", nBigger);
-
-    // print second line - matched original indices of the second organism
-    fprintf(pMatchingFile, "[ ");
-    for (iOrgPart = 0; iOrgPart < m_pMatching->GetObjectSize(nBigger); iOrgPart++)
-    {
-        int iSorted; // index of the iOrgPart after sorting (as used by matching)
-        int iSortedMatched; // index of the matched Part (after sorting)
-        int iOrginalMatched; // index of the matched Part (the original one)
-
-        // find the index of iOrgPart after sorting (in m_aDegrees)
-        for (iSorted = 0; iSorted < m_Mod[ nBigger ]->getPartCount(); iSorted++)
-        {
-            // for each iSorted, an index in the sorted m_aDegrees array
-            if (m_aDegrees[ nBigger ][ iSorted ][ 0 ] == iOrgPart)
-            {
-                // if the iSorted Part is the one with iOrgPart as the orginal index
-                // remember the index
-                break;
-            }
-        }
-        // if the index iSorted was found, then this condition is met
-        assert(iSorted < m_Mod[ nBigger ]->getPartCount());
-
-        // find the matched sorted index
-        if (m_pMatching->IsMatched(nBigger, iSorted))
-        {
-            // if Part iOrgPart is matched
-            // then get the matched Part (sorted) index
-            iSortedMatched = m_pMatching->GetMatchedIndex(nBigger, iSorted);
-            assert(iSortedMatched >= 0);
-            // and find its original index
-            iOrginalMatched = m_aDegrees[ 1 - nBigger ][ iSortedMatched ][ 0 ];
-            fprintf(pMatchingFile, "%2i ", iOrginalMatched);
-        }
-        else
-        {
-            // if the Part iOrgPart is not matched
-            // just print "X"
-            fprintf(pMatchingFile, " X ");
-        }
-    } // for ( iOrgPart )
-
-    // now all matched Part indices are printed out, end the line
-    fprintf(pMatchingFile, "] : ORG[%i]\n", 1 - nBigger);
-
-    // close the file
-    fclose(pMatchingFile);
-    // END TEMP
-
-    // TEMP
-    // print out the 2D positions of Parts of both of the organisms
-    // to files "org0.txt" and "org1.txt" using the original indices of Parts
-    int iModel; // index of a model (an organism)
-    FILE *pModelFile;
-    for (iModel = 0; iModel < 2; iModel++)
-    {
-        // for each iModel, a model of a compared organism
-        // write its (only 2D) positions to a file "org<iModel>.txt"
-        // construct the model filename "org<iModel>.txt"
-        std::string sModelFilename("org");
-        //		char *szModelIndex = "0"; // the index of the model (iModel) in the character form
-        char szModelIndex[2];
-        sprintf(szModelIndex, "%i", iModel);
-        sModelFilename += szModelIndex;
-        sModelFilename += ".txt";
-        // open the file for writing
-        pModelFile = fopen(sModelFilename.c_str(), "wt"); //FOPEN_WRITE
-        assert(pModelFile != NULL);
-        // write the 2D positions of iModel to the file
-        int iOriginalPart; // an original index of a Part
-        for (iOriginalPart = 0; iOriginalPart < m_Mod[ iModel ]->getPartCount(); iOriginalPart++)
-        {
-            // for each iOriginalPart, a Part of the organism iModel
-            // get the 2D coordinates of the Part
-            double dPartX = m_aPositions[ iModel ][ iOriginalPart ].x;
-            double dPartY = m_aPositions[ iModel ][ iOriginalPart ].y;
-            // print the line: <iOriginalPart> <dPartX> <dPartY>
-            fprintf(pModelFile, "%i %.4lf %.4lf\n", iOriginalPart, dPartX, dPartY);
-        }
-        // close the file
-        fclose(pModelFile);
-    }
+	assert(m_pMatching->IsFull() == true);
+	printf("Saving the matching to file 'matching.txt'\n");
+	FILE *pMatchingFile = NULL;
+	// try to open the file
+	pMatchingFile = fopen("matching.txt", "wt");
+	assert(pMatchingFile != NULL);
+
+	int iOrgPart; // original index of a Part
+	int nBigger; // index of the larger organism
+
+	// check which object is bigger
+	if (m_pMatching->GetObjectSize(0) >= m_pMatching->GetObjectSize(1))
+	{
+		nBigger = 0;
+	}
+	else
+	{
+		nBigger = 1;
+	}
+
+	// print first line - original indices of Parts of the bigger organism
+	fprintf(pMatchingFile, "[ ");
+	for (iOrgPart = 0; iOrgPart < m_pMatching->GetObjectSize(nBigger); iOrgPart++)
+	{
+		fprintf(pMatchingFile, "%2i ", iOrgPart);
+	}
+	fprintf(pMatchingFile, "] : ORG[%i]\n", nBigger);
+
+	// print second line - matched original indices of the second organism
+	fprintf(pMatchingFile, "[ ");
+	for (iOrgPart = 0; iOrgPart < m_pMatching->GetObjectSize(nBigger); iOrgPart++)
+	{
+		int iSorted; // index of the iOrgPart after sorting (as used by matching)
+		int iSortedMatched; // index of the matched Part (after sorting)
+		int iOrginalMatched; // index of the matched Part (the original one)
+
+		// find the index of iOrgPart after sorting (in m_aDegrees)
+		for (iSorted = 0; iSorted < m_Mod[nBigger]->getPartCount(); iSorted++)
+		{
+			// for each iSorted, an index in the sorted m_aDegrees array
+			if (m_aDegrees[nBigger][iSorted][0] == iOrgPart)
+			{
+				// if the iSorted Part is the one with iOrgPart as the orginal index
+				// remember the index
+				break;
+			}
+		}
+		// if the index iSorted was found, then this condition is met
+		assert(iSorted < m_Mod[nBigger]->getPartCount());
+
+		// find the matched sorted index
+		if (m_pMatching->IsMatched(nBigger, iSorted))
+		{
+			// if Part iOrgPart is matched
+			// then get the matched Part (sorted) index
+			iSortedMatched = m_pMatching->GetMatchedIndex(nBigger, iSorted);
+			assert(iSortedMatched >= 0);
+			// and find its original index
+			iOrginalMatched = m_aDegrees[1 - nBigger][iSortedMatched][0];
+			fprintf(pMatchingFile, "%2i ", iOrginalMatched);
+		}
+		else
+		{
+			// if the Part iOrgPart is not matched
+			// just print "X"
+			fprintf(pMatchingFile, " X ");
+		}
+	} // for ( iOrgPart )
+
+	// now all matched Part indices are printed out, end the line
+	fprintf(pMatchingFile, "] : ORG[%i]\n", 1 - nBigger);
+
+	// close the file
+	fclose(pMatchingFile);
+	// END TEMP
+
+	// TEMP
+	// print out the 2D positions of Parts of both of the organisms
+	// to files "org0.txt" and "org1.txt" using the original indices of Parts
+	int iModel; // index of a model (an organism)
+	FILE *pModelFile;
+	for (iModel = 0; iModel < 2; iModel++)
+	{
+		// for each iModel, a model of a compared organism
+		// write its (only 2D) positions to a file "org<iModel>.txt"
+		// construct the model filename "org<iModel>.txt"
+		std::string sModelFilename("org");
+		//		char *szModelIndex = "0"; // the index of the model (iModel) in the character form
+		char szModelIndex[2];
+		sprintf(szModelIndex, "%i", iModel);
+		sModelFilename += szModelIndex;
+		sModelFilename += ".txt";
+		// open the file for writing
+		pModelFile = fopen(sModelFilename.c_str(), "wt"); //FOPEN_WRITE
+		assert(pModelFile != NULL);
+		// write the 2D positions of iModel to the file
+		int iOriginalPart; // an original index of a Part
+		for (iOriginalPart = 0; iOriginalPart < m_Mod[iModel]->getPartCount(); iOriginalPart++)
+		{
+			// for each iOriginalPart, a Part of the organism iModel
+			// get the 2D coordinates of the Part
+			double dPartX = m_aPositions[iModel][iOriginalPart].x;
+			double dPartY = m_aPositions[iModel][iOriginalPart].y;
+			// print the line: <iOriginalPart> <dPartX> <dPartY>
+			fprintf(pModelFile, "%i %.4lf %.4lf\n", iOriginalPart, dPartX, dPartY);
+		}
+		// close the file
+		fclose(pModelFile);
+	}
 }
 
 /** Comparison function required for qsort() call. Used while sorting groups of
-    Parts with respect to degree. Compares two TDN structures
-    with respect to their [1] field (degree). Highest degree goes first.
-    @param pElem1 Pointer to the TDN structure of some Part.
-    @param pElem2 Pointer to the TDN structure of some Part.
-    @return (-1) - pElem1 should go first, 0 - equal, (1) - pElem2 should go first.
- */
+	Parts with respect to degree. Compares two TDN structures
+	with respect to their [1] field (degree). Highest degree goes first.
+	@param pElem1 Pointer to the TDN structure of some Part.
+	@param pElem2 Pointer to the TDN structure of some Part.
+	@return (-1) - pElem1 should go first, 0 - equal, (1) - pElem2 should go first.
+	*/
 int ModelSimil::CompareDegrees(const void *pElem1, const void *pElem2)
 {
-    int *tdn1 = (int *) pElem1;
-    int *tdn2 = (int *) pElem2;
-
-    if (tdn1[1] > tdn2[1])
-    {
-        // when degree - tdn1[1] - is BIGGER
-        return -1;
-    }
-    else
-        if (tdn1[1] < tdn2[1])
-    {
-        // when degree - tdn2[1] - is BIGGER
-        return 1;
-    }
-    else
-    {
-        return 0;
-    }
+	int *tdn1 = (int *)pElem1;
+	int *tdn2 = (int *)pElem2;
+
+	if (tdn1[1] > tdn2[1])
+	{
+		// when degree - tdn1[1] - is BIGGER
+		return -1;
+	}
+	else
+		if (tdn1[1] < tdn2[1])
+		{
+		// when degree - tdn2[1] - is BIGGER
+		return 1;
+		}
+		else
+		{
+			return 0;
+		}
 }
 
 /** Comparison function required for qsort() call. Used while sorting groups of Parts with
-        the same degree. Firstly, compare NIt. Secondly, compare Neu. If both are equal -
-        compare Parts' original index (they are never equal). So this sorting assures
-        that the order obtained is deterministic.
-    @param pElem1 Pointer to the TDN structure of some Part.
-    @param pElem2 Pointer to the TDN structure of some Part.
-    @return (-1) - pElem1 should go first, 0 - equal, (1) - pElem2 should go first.
- */
+		the same degree. Firstly, compare NIt. Secondly, compare Neu. If both are equal -
+		compare Parts' original index (they are never equal). So this sorting assures
+		that the order obtained is deterministic.
+		@param pElem1 Pointer to the TDN structure of some Part.
+		@param pElem2 Pointer to the TDN structure of some Part.
+		@return (-1) - pElem1 should go first, 0 - equal, (1) - pElem2 should go first.
+		*/
 int ModelSimil::CompareConnsNo(const void *pElem1, const void *pElem2)
 {
-    // pointers to TDN arrays 
-    int *tdn1, *tdn2;
-    // definitions of elements being compared
-    tdn1 = (int *) pElem1;
-    tdn2 = (int *) pElem2;
-
-    // comparison according to Neural Connections (to jest TDN[2])
-    if (tdn1[NEURO_CONNS] > tdn1[NEURO_CONNS])
-    {
-        // when number of NConn Elem1 is BIGGER
-        return -1;
-    }
-    else
-        if (tdn1[NEURO_CONNS] < tdn1[NEURO_CONNS])
-    {
-        // when number of NConn Elem1 is SMALLER
-        return 1;
-    }
-    else
-    {
-        // when numbers of NConn are EQUAL
-        // compare Neu numbers (TDN[3])
-        if (tdn1[NEURONS] > tdn2[NEURONS])
-        {
-            // when number of Neu is BIGGER for Elem1 
-            return -1;
-        }
-        else
-            if (tdn1[NEURONS] < tdn2[NEURONS])
-        {
-            // when number of Neu is SMALLER for Elem1 
-            return 1;
-        }
-        else
-        {
-            // when numbers of Nconn and Neu are equal we check original indices 
-            // of Parts being compared
-
-            // comparison according to OrgIndex
-            if (tdn1[ORIG_IND] > tdn2[ORIG_IND])
-            {
-                // when the number of NIt Deg1 id BIGGER
-                return -1;
-            }
-            else
-                if (tdn1[ORIG_IND] < tdn2[ORIG_IND])
-            {
-                // when the number of NIt Deg1 id SMALLER
-                return 1;
-            }
-            else
-            {
-                // impossible, indices are alway different
-                return 0;
-            }
-        }
-    }
-}
-
-/** Returns number of factors involved in final distance computation. 
-        These factors include differences in numbers of parts, degrees,
-        number of neurons.
- */
+	// pointers to TDN arrays 
+	int *tdn1, *tdn2;
+	// definitions of elements being compared
+	tdn1 = (int *)pElem1;
+	tdn2 = (int *)pElem2;
+
+	// comparison according to Neural Connections (to jest TDN[2])
+	if (tdn1[NEURO_CONNS] > tdn1[NEURO_CONNS])
+	{
+		// when number of NConn Elem1 is BIGGER
+		return -1;
+	}
+	else
+		if (tdn1[NEURO_CONNS] < tdn1[NEURO_CONNS])
+		{
+		// when number of NConn Elem1 is SMALLER
+		return 1;
+		}
+		else
+		{
+			// when numbers of NConn are EQUAL
+			// compare Neu numbers (TDN[3])
+			if (tdn1[NEURONS] > tdn2[NEURONS])
+			{
+				// when number of Neu is BIGGER for Elem1 
+				return -1;
+			}
+			else
+				if (tdn1[NEURONS] < tdn2[NEURONS])
+				{
+				// when number of Neu is SMALLER for Elem1 
+				return 1;
+				}
+				else
+				{
+					// when numbers of Nconn and Neu are equal we check original indices 
+					// of Parts being compared
+
+					// comparison according to OrgIndex
+					if (tdn1[ORIG_IND] > tdn2[ORIG_IND])
+					{
+						// when the number of NIt Deg1 id BIGGER
+						return -1;
+					}
+					else
+						if (tdn1[ORIG_IND] < tdn2[ORIG_IND])
+						{
+						// when the number of NIt Deg1 id SMALLER
+						return 1;
+						}
+						else
+						{
+							// impossible, indices are alway different
+							return 0;
+						}
+				}
+		}
+}
+
+/** Returns number of factors involved in final distance computation.
+		These factors include differences in numbers of parts, degrees,
+		number of neurons.
+		*/
 int ModelSimil::GetNOFactors()
 {
-    return ModelSimil::iNOFactors;
+	return ModelSimil::iNOFactors;
 }
 
